/*->c.ofile     */

/* Ovation!   (c) D. J. Pilling,  December 1988                     */
/*                   Filing System  Interface                         */


#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>



#include "os.h"
#include "wimp.h"
#include "sprite.h"
#include "bbc.h"
#include "flex.h"
#include "werr.h"






#include "transform.h"
#include "xprocess.h"
#include "fsx.h"
#include "bf.h"
#include "wos.h"
#include "etc.h"
#include "xmath.h"
#include "poll.h"
#include "err.h"
#include "filetype.h"


#include "str.h"
#include "constants.h"

#include "object.h"

#include "file.h"
#include "view.h"
#include "section.h"
#include "new.h"


#include "obj.h"
#include "xcolour.h"
#include "undo.h"
#include "pref.h"
#include "xredraw.h"
#include "curve.h"



#include "page.h"


#include "txstr.h"
#include "text.h"
#include "txprivate.h"
#include "spell.h"

#include "pxstr.h"
#include "pict.h"

#include "border.h"

#include "impex.h"


#include "line.h"

#include "xprint.h"
#include "prstr.h"



#include "odef.h"
#include "ostyle.h"

#include "ofile.h"



static HANDLE modulehandle;

#define EO100 (0x1000)



#define FHF_TEMPLATE  0x1
#define FHF_PRINTDATA 0x2


static int       lastmainbox;
static int       lastsect;
static int       lastpage;
static int       lastmainpagebox;
static int       loadstylesheet;
static int       lastmainsource;
static int       lastmainvsource;
static int       xbranch;
static int       maxpagewidth;
static int       maxpageheight;
static int       shellx;
static int       shelly;
static int       shellw;
static int       shellh;
static int       lasttextx;
static int       lasttexty;
static int       mainvline;
static int       lastframewidth;


static onewpage  oldnewpage;


static int    mark101;
static int    mark103;
static int    mark125;


static colourvalue xtrans={OURTRANS};




static textflowstr defltoldflow=
{
 0,           /* outset size */
 FRFWIDEST,
 FROFRAME,
 0,           /* changeo */
};





/* returns the size of an xstr to the nearest 32 bytes */

static int xsize(int type)
{
 int size;

 switch(type)
 {
     case XVBOX:
                size=32;
                break;

  case  XSOURCE:
  case XPICTURE:
  case   XFRAME:
  case   XSHELL:
                size=64;
                break;

        default:
                size=96;
                break;
 }

 return(size);
}





static os_error * loadobject(buffer * bf,xstr * x)
{
 bf_geti(bf,(int*)&x->next);
 bf_geti(bf,(int*)&x->prev);
 bf_geti(bf,(int*)&x->type);

 if(x->type<0 || x->type>XPICTURE) return(geterror(EO100));

 return(bf_read(bf,((char *)x)+3*sizeof(int),
                   xsize(x->type & 0xFF)-3*sizeof(int)));
}




static os_error * loadsource(buffer * bf,filestr * file,
                                                  int * tsource,int * vsource)
{
 os_error   * err;
 obuffer      buffer;
 int          dlen;
 sourcestr  * sourcep;
 vsourcestr * vsourcep;
 xstr         x;

          err=loadobject(bf,&x);
 if(!err) err=bf_read(bf,&buffer,sizeof(obuffer)-sizeof(int));
 if(!err)
 {
  dlen=buffer.len-sizeof(obuffer)+sizeof(int);

  err=fob_create(sizeof(sourcestr)-sizeof(int)+dlen,file,OSOURCE,
                                                         (objptr)&sourcep);
  if(!err)
  {
   err=bf_read(bf,sourcep->data,dlen);

   sourcep->maxlen=dlen;
   sourcep->len=dlen;
   sourcep->goffset=dlen;
   *tsource=sourcep->key;
   oremaptxsource(sourcep->key,file);

   if(!err)
   {
    err=bf_read(bf,&buffer,sizeof(obuffer)-sizeof(int));
    if(!err)
    {
     dlen=buffer.len-sizeof(obuffer)+sizeof(int);

     err=fob_create(sizeof(vsourcestr)-sizeof(int)+dlen,file,OVSOURCE,
                                                            (objptr)&vsourcep);
     if(!err)
     {
      err=bf_read(bf,vsourcep->data,dlen);

      vsourcep->maxlen=dlen;
      vsourcep->len=dlen;
      vsourcep->goffset=dlen;
      *vsource=vsourcep->key;
      oremapvsource(vsourcep->key,file);
     }
    }
   }
  }
 }

 return(err);
}





static os_error * loadpicture(buffer * bf,filestr * file,int * picture)
{
 os_error   * err;
 obuffer      buffer;
 int          dlen;
 picturestr * picturep;
 xstr         x;

 err=loadobject(bf,&x);

 *picture=0;

 if(!err && x.u.picture.anchor)
 {
  err=bf_read(bf,&buffer,sizeof(obuffer)-sizeof(int));
  if(!err)
  {
   dlen=buffer.len-sizeof(obuffer)+sizeof(int);

   err=fob_create(sizeof(picturestr)-sizeof(int)+dlen,file,OPICTURE,
                                                         (objptr)&picturep);
   if(!err)
   {
    *picture=picturep->key;

    fob_setbits(*picture,file,OBJ_CCINSTANCE,(fobjptr)&picturep);

    err=bf_read(bf,picturep->data,dlen);

    picturep->ftype=x.u.picture.type;

    picturep->imagelen=dlen;

    if(mark103)
    {
     picturep->abox.x0=x.u.picture.x0*256;
     picturep->abox.x1=x.u.picture.x1*256;
     picturep->abox.y0=x.u.picture.y0*256;
     picturep->abox.y1=x.u.picture.y1*256;
    }
    else
    {
     picturep->abox.x0=x.u.picture.x0;
     picturep->abox.x1=x.u.picture.x1;
     picturep->abox.y0=x.u.picture.y0;
     picturep->abox.y1=x.u.picture.y1;
    }
   }
  } 
 }
 return(err);
}





typedef struct mainboxstr
{
 int source[2];    /* header =0, footer =1 */
 int vsource[2];
 int margin[2];
 int bytes[8+2];
 int vlines[8+2];
 int vbox[8+2];
 int x[8+2];
 int y[8+2];
 int full[3];
} mainboxstr;



static mainboxstr xmain;



static colourvalue pagecolour={OURWHITE};


#define OUSERINDEX 6

static char * onames[]={
                         "A3",
                         "A4",
                         "A5",
                         "Letter",
                         "Legal",
                         "Tabloid",
                         "Other",
                       };



#define OLDLINESTYLES 5


typedef struct olinemapstr
{
 int style;
 int scale;
} olinemapstr;


static olinemapstr olinemap[OLDLINESTYLES]=
{
  0xFFFFFFFF, 5120,
  0xFCFCFCFC, 2880,
  0xEEEEEEEE, 3840,
  0xAAAAAAAA, 5120,
  0xFAFAFAFA, 3200,
};




static void framefix(curvestr * c,int frame)
{
 if(frame)
 {
  c->box.x+=lastframewidth;
  c->box.w-=2*lastframewidth;
  c->box.y+=lastframewidth;
  c->box.h-=2*lastframewidth;
 }
}


static void vframefix(int vbox,filestr * file,int frame)
{
 textvbox  * vboxp;

 if(frame && vbox)
 {
  vboxp=(textvbox*)fob_find(vbox,file);
  vboxp->curve[0].box.x-=lastframewidth;
  vboxp->curve[0].box.y-=lastframewidth;
 }
}




static char * o1bordernames[]=
{

 "1_Plain",
 "2_Double1",
 "3_Double2",
 "4_Double3",
 "5_Triple1",
 "6_Dotted1",
 "7_Double4",
 "8_Quad1",

};




static os_error * loadxstr(int p,int * z,buffer * bf,filestr * file)
{
 os_error       * err;
 int              s;
 int              x;
 xstr             xp;
 int            * fz;
 int              column;
 int              xcolumn;
 int              mainlevel;



 err=NULL;

 mainlevel=column=xcolumn=0;

 fz=z;
 x=*z;


 while(x && !err)
 {
  err=loadobject(bf,&xp);
  if(err) break;

/*  dprintf(0,"loadx p=%d x=%d type=%d",p,x,xp.type); */

  switch(xp.type)
  {
    case XSECT:
               {
                sectiondatastr  sectiondata;
                sectionmapstr   map;
                objectloc       loc;
                sobjectstr    * sob;

                memset(&loc,0,sizeof(objectloc));
                loc.file=file;
                loc.branch=xbranch;

                memset(&sectiondata,0,sizeof(sectiondatastr));

                sectiondata.colour[0]=pagecolour;
                sectiondata.colour[1]=pagecolour;
                sectiondata.number=xp.u.section.secno;
                sectiondata.pagenumber.format=xp.u.section.format;
                sectiondata.pagenumber.start=xp.u.section.start;
                sectiondata.pagenumber.number=xp.u.section.number;
                sectiondata.pagenumber.left=((xp.u.section.number & 0x1)==0);
                sectiondata.shape=oldnewpage.shape;
                sectiondata.width=oldnewpage.width;
                sectiondata.height=oldnewpage.height;
                strcpy(sectiondata.size,onames[oldnewpage.size]);
                sectiondata.usersize=(oldnewpage.size==OUSERINDEX);

                objectnew(&loc,OSECTION,&sectiondata);
                x=loc.object;

                sob=(sobjectstr*)fob_find(x,file);
                ((sectionstr*)sob)->np=xp.u.section.np;

                if(xp.prev)
                {
                 sob->chain.prev=p;
                 sob=(sobjectstr*)fob_find(p,file);
                 sob->chain.next=x;
                }
                else
                { 
                 *z=x;
                }

                loadsource(bf,file,&lastmainsource,&lastmainvsource);

                lastsect=x;
                lastmainbox=0;
                lastpage=0;
                mainvline=0;

                memset(&map,0,sizeof(sectionmapstr));
                if(xbranch)
                {
                 map.msource=lastmainsource;
                 map.mvsource=lastmainvsource;
                }
                else
                {
                 map.dsource=lastmainsource;
                 map.dvsource=lastmainvsource;
                }

                sectionaddmap(&map,lastsect,file,xbranch);
               }
               err=loadxstr(x,(int*)&xp.u.section.page,bf,file);
               break;


    case XPAGE:
               {
                objectloc    loc;
                newpagestr   newpage;
                sobjectstr * sob;

                memset(&loc,0,sizeof(objectloc));
                loc.branch=xbranch;
                loc.file=file;
                loc.section=lastsect;

                memset(&newpage,0,sizeof(newpagestr));

                newpage.data.colour[0]=pagecolour;
                newpage.data.colour[1]=pagecolour;
                newpage.data.width=xp.w;
                newpage.data.height=xp.h;
                newpage.pagenumber=xp.u.page.number;

                maxpagewidth=MAX(maxpagewidth,xp.w);
                maxpageheight=MAX(maxpageheight,xp.h);

                objectnew(&loc,OPAGE,&newpage);
                x=loc.object;
                lastpage=x;
                lastmainpagebox=0;

                sob=(sobjectstr*)fob_find(p,file);
                if(xp.prev && sob->type==OPAGE)
                {
                 sob->chain.next=x;
                 sob=(sobjectstr*)fob_find(x,file);
                 sob->chain.prev=p;
                 ((pagestr*)sob)->section=lastsect;

                 if(xbranch)
                 {
                  sob=(sobjectstr*)fob_find(lastsect,file);
                  ((sectionstr*)sob)->data.dble=1;
                 }
                }
                else
                { 
                 sob=(sobjectstr*)fob_find(lastsect,file);
                 ((sectionstr*)sob)->chain.child=x;
                 ((sectionstr*)sob)->data.width=xp.w;
                 ((sectionstr*)sob)->data.height=xp.h;


/*           dprintf(0,"sect %d %d",
                   ((sectionstr*)sob)->data.pagenumber.number,
                   ((sectionstr*)sob)->data.pagenumber.left); */

                 if(!xbranch) /* fix up for bad documents */
                 {
                  ((sectionstr*)sob)->data.pagenumber.number=
                                                     xp.u.page.number;
                  ((sectionstr*)sob)->data.pagenumber.left=
                                             ((xp.u.page.number & 0x1)==0);
                 }

/*           dprintf(0,"sect %d %d",
                 ((sectionstr*)sob)->data.pagenumber.number,
                 ((sectionstr*)sob)->data.pagenumber.left);   */


                 sob=(sobjectstr*)fob_find(x,file);
                 ((pagestr*)sob)->section=lastsect;
                }
               }
                        err=loadxstr(0,(int*)&xp.u.page.gux,bf,file);
               if(!err) err=loadxstr((int)xp.u.page.gux,
                                          (int*)&xp.u.page.guy,bf,file);
               if(!err) err=loadxstr(x,(int*)&xp.u.page.child,bf,file);
               break;


   case XSHELL:
               shellx=xp.x;
               shelly=xp.y;
               shellw=xp.w;
               shellh=xp.h;

               err=loadxstr(x,(int*)&xp.u.shell.sub,bf,file);


               if(!err)
               {
                *z=x=(int)xp.u.shell.sub;

                         err=loadxstr(x,(int*)&xp.u.shell.child,bf,file);
                if(!err) err=loadxstr(x,(int*)&xp.u.shell.frame,bf,file);
                if(!err)
                {
                 sobjectstr     * sob;
                 textboxstr     * textp;
                 texsub         * texup;
                 texsrc         * texsp; 
                 int              rstart;
                 int              usize;
                 int              i;

                 if(xp.u.shell.frame)
                 {
                  textp=(textboxstr*)fob_find(lastmainbox,file);
                  textp->frame=(int)xp.u.shell.frame;
                  framefix(&textp->fcurve,(int)xp.u.shell.frame);
                  framefix(&textp->icurve,(int)xp.u.shell.frame);

                  if(textp->data.header || textp->data.footer)
                  {
                   usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr);
                   xcolumn=2+textp->data.columns;
                   rstart=2;
                  }
                  else
                  {
                   usize=sizeof(textboxstr)+sizeof(texsrc);
                   xcolumn=textp->data.columns;
                   rstart=0;
                  }

                  texup=(texsub*)(((char*)textp)+usize);
                  for(i=0;i<xcolumn;i++)
                  {
                   vframefix(texup[i].vbox,file,(int)xp.u.shell.frame);
                  }

                  texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

                  for(i=0;i<2;i++)
                  {
                   if((i==0 && textp->data.header) ||
                      (i==1 && textp->data.footer))
                   {
                    ovlineshift(file,texsp[i+1].vsource,
                                     texup[i].vlines,0,
                                     0,
                                     -lastframewidth);
                   }
                  }

                  usize=mainvline;

                  for(i=xcolumn-1;i>=rstart;i--)
                  {
                   usize-=texup[i].vlines;
                   ovlineshift(file,lastmainvsource,texup[i].vlines,usize,
                                     -lastframewidth,-lastframewidth);
                  }
                 }

                 p=x;
                 while(1)
                 {
                  sob=(sobjectstr*)fob_find(p,file);
                  p=sob->chain.next;
                  if(!p) break;
                  x=p;
                 }
                }
               }
               break;


    case XMAIN:
  case XHEADER:
  case XFOOTER:
               if(!mainlevel) 
               {
                memset(&xmain,0,sizeof(mainboxstr));
                mainlevel=1;
               }

               if(xp.type==XFOOTER || xp.type==XHEADER)
               {
                int source;
                int vsource;
                int i;

                i=(xp.type==XFOOTER);

                if(((int)xp.u.text.fprev)==1)  /* loading a source */
                {
                 loadsource(bf,file,&source,&vsource);
                }

                lasttextx=shellx;
                lasttexty=shelly;

                         err=loadxstr(x,(int*)&xp.u.text.child,bf,file);
                if(!err) err=loadxstr(x,(int*)&xp.u.text.vbox,bf,file);
                if(!err) err=loadxstr(x,(int*)&xp.u.text.frame,bf,file);


                if(!err)
                {
                 xmain.source[i]=source;
                 xmain.vsource[i]=vsource;
                 xmain.vbox[i]=(int)xp.u.text.vbox;
                 xmain.margin[i]=xp.h;
                 xmain.bytes[i]=xp.u.text.bytes;
                 xmain.vlines[i]=xp.u.text.lines;

                 xmain.x[i]=xp.x;
                 xmain.y[i]=xp.y;
                 xmain.full[i]=(xp.f1 & XFULLBOX);
                }
               }
               else
               {
                lasttextx=shellx;
                lasttexty=shelly;

                xmain.x[2+column]=xp.x;
                xmain.y[2+column]=xp.y;
                if(!column) xcolumn=xp.w;

                         err=loadxstr(x,(int*)&xp.u.text.child,bf,file);
                if(!err) err=loadxstr(x,(int*)&xp.u.text.vbox,bf,file);
                if(!err) err=loadxstr(x,(int*)&xp.u.text.frame,bf,file);

                if(!err)
                {
                 xmain.bytes[2+column]=xp.u.text.bytes;
                 xmain.vlines[2+column]=xp.u.text.lines;
                 xmain.vbox[2+column]=(int)xp.u.text.vbox;
                 xmain.full[2]=(xp.f1 & XFULLBOX);

                 column++;
                }
               }

               if(!xp.next)
               {
                unpackedtextdatastr textdata;
                objectloc           loc;
                curvestr            cbox;
                int                 i;
                int                 margins;
                int                 rstart;
                int                 usize;
                colourvalue         cv;
                sobjectstr        * sob;
                texsrc            * texsp; 
                texhdr            * texthp;
                texsub            * texup;


                memset(&loc,0,sizeof(objectloc));

                loc.file=file;
                loc.section=lastsect;
                loc.page=lastpage;
                loc.parent=lastpage;
                loc.after=0;
                loc.chain=0;
                loc.branch=xbranch;
                loc.copymode=LOCNVBOX;

                cbox.type=CBOX;
                cbox.box.w=shellw;
                cbox.box.h=shellh;
                cbox.box.x=shellx;
                cbox.box.y=shelly;


                getdeflttextdata(&textdata);
                textdata.columns=column;

                if(column>1) 
                    textdata.columndata.width=
                         xmain.x[1+2]-xmain.x[0+2]-xcolumn;
                else
                    textdata.columndata.width=oldnewpage.gutter;

                textdata.header=xmain.margin[0];
                textdata.footer=xmain.margin[1];
                textdata.repeat=1;

                margins=xmain.margin[0] || xmain.margin[1];

                createtexts(&loc,&cbox,&textdata,&defltoldflow);

                if(xbranch) setupmainframe(&loc);

                x=loc.object;

                getcolour(xp.u.text.colour,xp.u.text.trans,&cv,file);

                sob=(sobjectstr*)fob_find(x,file);
                ((textboxstr*)sob)->data.i=xp.u.text.i;
                ((textboxstr*)sob)->data.colour=cv;
                ((textboxstr*)sob)->textflow.o=xp.u.text.o;
                ((textboxstr*)sob)->flags.full=(xmain.full[2]!=0);
                if(xp.u.text.trans)((textboxstr*)sob)->textflow.omode=FRONONE;

                texsp=(texsrc*)(((char*)sob)+sizeof(textboxstr));

                texsp[0].source=lastmainsource;
                texsp[0].vsource=lastmainvsource;


                if(margins)
                {
                 for(i=0;i<2;i++)
                 {
                  texsp[i+1].source=xmain.source[i];
                  texsp[i+1].vsource=xmain.vsource[i];
                 }

                 texthp=(texhdr*)(((char*)sob)+sizeof(textboxstr)+
                                                    3*sizeof(texsrc));
                 texthp->header=xmain.margin[0];
                 texthp->footer=xmain.margin[1];
                 texthp->headerfull=(xmain.full[0]!=0);
                 texthp->footerfull=(xmain.full[1]!=0);
                 texthp->headerdata=1;
                 texthp->footerdata=1;

                 usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr);
                 rstart=0;
                 xcolumn=column+2;
                }
                else
                {
                 usize=sizeof(textboxstr)+sizeof(texsrc);
                 rstart=2;
                 xcolumn=column;
                }


                texup=(texsub*)(((char*)sob)+usize);

                for(i=0;i<xcolumn;i++)
                {
                 texup[i].bytes=xmain.bytes[i+rstart];
                 texup[i].vlines=xmain.vlines[i+rstart];
                 texup[i].vbox=xmain.vbox[i+rstart];
                 texup[i].vdelta=0;
                }

                ((textboxstr*)sob)->fchain.prev=lastmainbox;


                if(lastmainbox)
                {
                 sob=(sobjectstr*)fob_find(lastmainbox,file);
                 ((textboxstr*)sob)->fchain.next=x;
                }

                lastmainbox=x;
                lastmainpagebox=x;


                for(i=0;i<column;i++)
                {
                 ovlineshift(file,lastmainvsource,
                                  xmain.vlines[i+2],
                                  mainvline,
                                  xmain.x[i+2]-shellx,
                                  xmain.y[i+2]-shelly);

                 mainvline+=xmain.vlines[i+2];
                }

                for(i=0;i<2;i++)
                {
                 if(xmain.margin[i])
                 {
                  ovlineshift(file,xmain.vsource[i],
                                   xmain.vlines[i],0,
                                   xmain.x[i]-shellx,
                                   xmain.y[i]-shelly);
                 }
                }

                *fz=x;
               }

               break;


    case XTEXT:
               {
                sobjectstr         * sob;
                objectloc            loc;
                curvestr             cbox;
                colourvalue          cv;
                int                  source;
                int                  vsource;
                unpackedtextdatastr  textdata;
                texsrc             * texsp;
                texsub             * texup;

                memset(&loc,0,sizeof(objectloc));

                loc.file=file;
                loc.section=lastsect;
                loc.page=lastpage;
                loc.parent=lastpage;
                loc.after=lastmainpagebox?p:0;

                      /* child of header etc. frame may exist - i.e. p not */
                      /* set up at all.                                    */

                loc.chain=0;
                loc.branch=xbranch;
                loc.copymode=LOCNVBOX;

                cbox.type=CBOX;
                cbox.box.w=xp.w;
                cbox.box.h=xp.h;
                cbox.box.x=xp.x;
                cbox.box.y=xp.y;

                getdeflttextdata(&textdata);

                createtexts(&loc,&cbox,&textdata,&defltoldflow);

                x=loc.object;
                if(!xp.prev) *z=x;

                if(((int)xp.u.text.fprev)==1)  /* loading a source */
                {
                 loadsource(bf,file,&source,&vsource);
                }
                else
                {
                 source=vsource=0;
                }

                err=loadxstr(x,(int*)&xp.u.text.child,bf,file);
                if(!err)
                {
                 lasttextx=xp.x;
                 lasttexty=xp.y;

                          err=loadxstr(x,(int*)&xp.u.text.vbox,bf,file);
                 if(!err) err=loadxstr(x,(int*)&xp.u.text.frame,bf,file);
                 if(!err)
                 {
                  getcolour(xp.u.text.colour,xp.u.text.trans,&cv,file);

                  sob=(sobjectstr*)fob_find(x,file);
                  ((textboxstr*)sob)->data.repeat=0;
                  ((textboxstr*)sob)->data.i=xp.u.text.i;
                  ((textboxstr*)sob)->data.colour=cv;
                  ((textboxstr*)sob)->textflow.o=xp.u.text.o;
                  ((textboxstr*)sob)->textflow.fmode=FRFWIDEST;
                  ((textboxstr*)sob)->frame=(int)xp.u.text.frame;
                  ((textboxstr*)sob)->flags.full=((xp.f1 & XFULLBOX)!=0);

                  if(xp.u.text.trans)
                              ((textboxstr*)sob)->textflow.omode=FRONONE;

                  framefix(&sob->fcurve,(int)xp.u.text.frame);
                  framefix(&sob->icurve,(int)xp.u.text.frame);

                  txboundingcurves((textboxstr**)&sob,file,
                                                 BCDEL|BCINNER|BCOUTER);

                  if((int)xp.u.text.fnext & 0x80000000)
                      ((textboxstr*)sob)->fchain.next=(int)xp.u.text.fnext;
                  if((int)xp.u.text.fprev & 0x80000000)
                      ((textboxstr*)sob)->fchain.prev=(int)xp.u.text.fprev;

                  texsp=(texsrc*)(((char*)sob)+sizeof(textboxstr));

                  texsp[0].source=source;
                  texsp[0].vsource=vsource;

                  texup=(texsub*)(((char*)sob)+
                                           sizeof(textboxstr)+sizeof(texsrc));
               
                  texup->bytes=xp.u.text.bytes;
                  texup->vlines=xp.u.text.lines;
                  texup->vbox=(int)xp.u.text.vbox;
                  texup->vdelta=0;

                  vframefix((int)xp.u.text.vbox,file,(int)xp.u.text.frame);

                  p=x;
                  while(1)
                  {
                   sob=(sobjectstr*)fob_find(p,file);
                   p=sob->chain.next;
                   if(!p) break;
                   x=p;
                  }
                 }
                }
               }
               break;


    case XPICT:
               {
                sobjectstr * sob;
                objectloc    loc;
                curvestr     cbox;
                colourvalue  cv;

                memset(&loc,0,sizeof(objectloc));

                loc.file=file;
                loc.section=lastsect;
                loc.page=lastpage;
                loc.parent=lastpage;
                loc.after=lastmainpagebox?p:0;
                loc.chain=0;
                loc.branch=xbranch;
                loc.copymode=0;

                cbox.type=CBOX;
                cbox.box.w=xp.w;
                cbox.box.h=xp.h;
                cbox.box.x=xp.x;
                cbox.box.y=xp.y;

                err=objectcreate(&loc,OPICTBOX,&cbox);
                if(!err)
                {
                 x=loc.object;

                 sob=(sobjectstr*)fob_find(p,file);
                 if(!xp.prev) *z=x;

                 if(((int)xp.u.pict.fprev)==1)
                 {
                  err=loadpicture(bf,file,&s);
                  if(!err)
                  {
                   sob=(sobjectstr*)fob_find(x,file);
                   ((pictboxstr*)sob)->picture=s;
                  }
                 }

                 if(!err)
                 {
                  if(mark101) 
                  {
                   xp.u.pict.xmul=xp.u.pict.xdiv=100;
                   xp.u.pict.ymul=xp.u.pict.ydiv=100;
                  }

                  if(mark125) xp.u.pict.angle=0;

                  getcolour(xp.u.pict.colour,xp.u.pict.trans,&cv,file);

                  sob=(sobjectstr*)fob_find(x,file);

                  ((pictboxstr*)sob)->pictdata.scale=
                               scale(0x10000,xp.u.pict.ymul,xp.u.pict.ydiv);

                  ((pictboxstr*)sob)->pictdata.aspect=
                               scale(0x10000,xp.u.pict.xmul*xp.u.pict.ydiv,
                                             xp.u.pict.ymul*xp.u.pict.xdiv);

                  ((pictboxstr*)sob)->pictdata.angle=-
                     (int)((((double)xp.u.pict.angle)*180.0)/PI);

                  ((pictboxstr*)sob)->pictdata.xshift=xp.u.pict.xshift;
                  ((pictboxstr*)sob)->pictdata.yshift=xp.u.pict.yshift;
                  ((pictboxstr*)sob)->data.i=xp.u.pict.i;
                  ((pictboxstr*)sob)->data.colour=cv;
                  ((pictboxstr*)sob)->textflow.o=xp.u.pict.o;
                  ((pictboxstr*)sob)->textflow.fmode=FRFWIDEST;
                  ((pictboxstr*)sob)->flags.changed=1;

                  if(xp.u.pict.trans)
                                  ((pictboxstr*)sob)->textflow.omode=FRONONE;

                  pxboundingcurves((pictboxstr**)&sob,file,
                                                    BCDEL|BCINNER|BCOUTER);

                  if((int)xp.u.pict.fnext & 0x80000000)
                                ((pictboxstr*)sob)->ftype=(int)xp.u.pict.fnext;

                           err=loadxstr(x,(int*)&xp.u.pict.child,bf,file);
                  if(!err) err=loadxstr(x,(int*)&xp.u.pict.frame,bf,file);
               
                  sob=(sobjectstr*)fob_find(x,file);
                  ((pictboxstr*)sob)->frame=(int)xp.u.pict.frame;
                  framefix(&sob->fcurve,(int)xp.u.pict.frame);
                  framefix(&sob->icurve,(int)xp.u.pict.frame);

                  if(!err)
                  {
                   p=x;
                   while(1)
                   {
                    sob=(sobjectstr*)fob_find(p,file);
                    p=sob->chain.next;
                    if(!p) break;
                    x=p;
                   }
                  }
                 }
                }
               }
               break;


    case XLINE:
               {
                sobjectstr * sob;
                objectloc    loc;
                curvestr     cbox;
                colourvalue  cv;
                int          swop;
                int          yswop;
                pathstyle    pstyle;

                memset(&loc,0,sizeof(objectloc));

                loc.file=file;
                loc.section=lastsect;
                loc.page=lastpage;
                loc.parent=lastpage;
                loc.after=lastmainpagebox?p:0;
                loc.chain=0;
                loc.branch=xbranch;
                loc.copymode=0;


                if(xp.u.line.ox>xp.u.line.ex)
                {
                 cbox.box.x=xp.u.line.ex;
                 cbox.box.w=xp.u.line.ox-xp.u.line.ex;
                 swop=0;
                }
                else
                {
                 cbox.box.x=xp.u.line.ox;
                 cbox.box.w=xp.u.line.ex-xp.u.line.ox;
                 swop=1;
                }

                if(xp.u.line.oy>xp.u.line.ey)
                {
                 cbox.box.y=xp.u.line.ey;
                 cbox.box.h=xp.u.line.oy-xp.u.line.ey;
                 yswop=1;
                }
                else
                {
                 cbox.box.y=xp.u.line.oy;
                 cbox.box.h=xp.u.line.ey-xp.u.line.oy;
                 swop^=1;
                 yswop=0;
                }


                cbox.type=swop?CLINEX:CLINE;

                err=objectcreate(&loc,OLINE,&cbox);

                if(!err)
                {
                 getcolour(xp.u.line.colour,0,&cv,file);

                 x=loc.object;

                 if(!xp.prev) *z=x;

                 sob=(sobjectstr*)fob_find(x,file);
                 ((linestr*)sob)->data.thickness=xp.u.line.thickness;
                 ((linestr*)sob)->data.linecolour=cv;
                 ((linestr*)sob)->data.fillcolour=xtrans;

                 if(xp.u.line.style>=0 && xp.u.line.style<OLDLINESTYLES)
                 {
                  ((linestr*)sob)->data.style=olinemap[xp.u.line.style].style;
                  ((linestr*)sob)->data.stylescale=
                                              olinemap[xp.u.line.style].scale;
                 }

                 ((linestr*)sob)->data.startcaps=(xp.u.line.endcaps & 0x2)?3:0;
                 ((linestr*)sob)->data.endcaps  =(xp.u.line.endcaps & 0x1)?3:0;

                 if(yswop) SWOP(((linestr*)sob)->data.endcaps,
                                ((linestr*)sob)->data.startcaps);

                 XMEMCPYX(&pstyle,&((linestr*)sob)->data.thickness,
                                                         sizeof(pathstyle));
                 pstyle.action=0x3;

                 truecurvebox(&((linestr*)sob)->fcurve,&pstyle,file,NULL,
                              &((linestr*)sob)->xcurve.box);

                 ((linestr*)sob)->box=((linestr*)sob)->xcurve.box;
                }
               }
               break;


    case XVBOX:
               {
                sobjectstr * sob;

                err=fob_create(sizeof(textvbox),file,OTEXTVBOX,(objptr)&sob);
                if(!err)
                {
                 x=sob->key;

                 ((textvbox*)sob)->nc=1;
                 ((textvbox*)sob)->curve[0].type=CBOX;
                 ((textvbox*)sob)->curve[0].box.x=xp.x-lasttextx;
                 ((textvbox*)sob)->curve[0].box.y=xp.y-lasttexty;
                 ((textvbox*)sob)->curve[0].box.w=xp.w;
                 ((textvbox*)sob)->curve[0].box.h=xp.h;

                 if(xp.prev)
                 {
                  sob=(sobjectstr*)fob_find(p,file);
                  ((textvbox*)sob)->down=x;
                 }
                 else
                 {
                  *z=x;
                 }
                }
               }
               break;


  case XGUIDEX:
  case XGUIDEY:
               {
                objectloc    loc;
                curvestr     cbox;

                memset(&loc,0,sizeof(objectloc));

                loc.file=file;
                loc.section=lastsect;
                loc.page=lastpage;
                loc.parent=lastpage;
                loc.after=p;
                loc.chain=PGLINECHAIN;
                loc.branch=xbranch;
                loc.copymode=0;

                memset(&cbox,0,sizeof(curvestr));

                cbox.type=CLINE;

                if(xp.type==XGUIDEY)
                {
                 cbox.box.h=xp.h;
                 cbox.box.x=xp.x;
                }
                else
                {
                 cbox.box.w=xp.w;
                 cbox.box.y=xp.y;
                }

                err=objectcreate(&loc,OGLINE,&cbox);
                if(!err)
                {
                 x=loc.object;

                 if(!xp.prev) *z=x;
                }
               }
               break;


   case XFRAME:
               {
                int         i;
                colourvalue cv;

                modifyborderdatastr border;
                memset(&border,0,sizeof(modifyborderdatastr));

                if(xp.u.frame.name[0]=='0' && 
                   xp.u.frame.name[1]>='1' && xp.u.frame.name[1]<='7')
                             i=xp.u.frame.name[1]-'1';
                else         i=0;

            /*    getbordername(border.border.name,i);  */

                strcpy(border.border.name,o1bordernames[i]);


                getcolour(xp.u.frame.colour,0,&cv,file);

                border.border.border[BORDER].colour=cv;
                border.border.border[BORDER].mode=0xF;
                border.border.border[BORDER].width=
                                             lastframewidth=xp.u.frame.size;

                border.border.border[SHADOW]=border.border.border[BORDER];

                                       /* logic is shadow is zeroed */
                border.border.border[BORDER].active=1;
                border.bits[BORDER].xactive=1;

                createborder(&border,file,z,0);
               }
               break;

       default:
               *z=0;
               return(err);
               break;

  }

  p=x;
  z=(int*)&xp.next;
  x=(int)xp.next;
 } 


 return(err);
}





static os_error * readstring(char * s,buffer * bf)
{
 int len;
 bf_geti(bf,&len);
 return(bf_read(bf,s,len+1));
}





#define OPORT   0x1
#define OPAM    0x2
#define OGAL    0x4

#define OFITX   0x8
#define OFITY  0x10
#define OCENTX 0x20
#define OCENTY 0x40

#define OREGM  0x80



#define DCHUNK 12

/* return 1 if any errors */

static os_error * readfhdc(buffer * bf,filestr * file)
{
 os_error * err;
 spdictstr  spdict[DCHUNK];
 int        i;
 int        j;
 int        n;
 spellstr * spellp;
 int        spellk;

 err=NULL;

 spellk=file->hdr.spell;

 i=n=0;

 while(1)
 {
  i=0;
  memset(spdict,0,DCHUNK*sizeof(spdictstr));

  while(1)
  {
   bf_read(bf,spdict[i].name,12);
   if(!strlen(spdict[i].name)) break;
   i++;
   if(i>=DCHUNK) break;
  }

  if(i)
  {
   n+=i;
   err=fob_change(spellk,file,sizeof(spellstr)+n*sizeof(spdictstr),
                                                       (fobjptr)&spellp);
   for(j=0;j<i;j++)
   {
    spellp->spdict[n-i+j]=spdict[j];
   }

   spellp->nodc=n;
  }

  if(i<DCHUNK) break;
 }

 return(err);
}






static os_error * readfileblock(buffer * bf,filestr * file)
{
 os_error * err;
 ouhead     fh_uhead;
 oghead     fh_ghead;
 int        block[31];
 int        ason;
 int        astime;
 int        ccheck;
 int        sps;
 int        collate;
 int        reverse;
 int        pause;
 int        ppics;
 int        whole;
 int        xcase;
 int        wild;
 int        fs;

 int        ruler;
 int        guides;
 int        xdouble;
 int        show;
 int        mul;
 int        div;

 int        defmul;
 int        defdiv;
 int        opt;
 int        margin;
 int        snap;
 int        measure;

 opset      pset;

 int        flags;

 int        copies;
 int        draft;
 int        oew;
 int        all;
 int        merge;
 char       froms[12];
 char       tos[12];
 char       mname[128];

 int        sheet;

 prefdatastr * prefs;

 oprintstr   * op;

 spellstr    * spellp;



 err=NULL;

 bf_read(bf,&fh_uhead,sizeof(ouhead));
 bf_read(bf,&fh_ghead,sizeof(oghead));

 mark101=strcmp(fh_uhead.mark,"1.01")<=0;
 mark103=strcmp(fh_uhead.mark,"1.03")<=0;
 mark125=strncmp(fh_uhead.mark,"1.25",4)<=0;

 bf_geti(bf,&ason);
 bf_geti(bf,&astime);
 bf_geti(bf,&ccheck);

 readfhdc(bf,file);

 bf_geti(bf,&sps);
 bf_geti(bf,&collate);
 bf_geti(bf,&reverse);
 bf_geti(bf,&pause);
 bf_geti(bf,&ppics);

 bf_geti(bf,&whole);
 bf_geti(bf,&xcase);
 bf_geti(bf,&wild);
 bf_geti(bf,&fs);

 bf_geti(bf,&ruler);
 bf_geti(bf,&guides);
 bf_geti(bf,&xdouble);
 bf_geti(bf,&show);
 bf_geti(bf,&mul);
 bf_geti(bf,&div);

 bf_geti(bf,&defmul);
 bf_geti(bf,&defdiv);
 bf_geti(bf,&opt);
 bf_geti(bf,&margin);
 bf_geti(bf,&snap);
 bf_geti(bf,&measure);


 bf_read(bf,&pset,sizeof(opset));

 bf_read(bf,&oldnewpage,sizeof(onewpage));

 bf_geti(bf,&flags);

 bf_read(bf,block,sizeof(block));


 if(flags & FHF_PRINTDATA)
 {
  bf_geti(bf,&copies);
  bf_geti(bf,&draft);
  bf_geti(bf,&oew);
  bf_geti(bf,&all);
  bf_geti(bf,&merge);
  readstring(froms,bf);
  readstring(tos,bf);
  readstring(mname,bf);
  bf_geti(bf,&sheet);
 }

 prefs=prefp(file);

 prefs->smallsize=(2*0x10000)/3;

/*
 prefs->subsize=(3*0x10000)/5;
 prefs->supersize=(3*0x10000)/5;
*/

 prefs->units=measure;
 prefs->autosave=ason;
 prefs->autosaveperiod=astime*60*100;

 prefs->chapterstart=1;


 file->hdr.viewdata.rulers=ruler;
 file->hdr.viewdata.units=measure;
 file->hdr.viewdata.guides=guides;
 file->hdr.viewdata.pictures=show;
 file->hdr.viewdata.margins=margin;
 file->hdr.viewdata.zoom.mul=mul;
 file->hdr.viewdata.zoom.div=div;
 file->hdr.viewdata.defzoom.mul=defmul;
 file->hdr.viewdata.defzoom.div=defdiv;
 file->hdr.viewdata.zoomopt=opt;
 file->hdr.viewdata.dble=xdouble;

 op=(oprintstr*)fob_find(file->hdr.print,file);

 op->pr.fitx=((pset.flags & OFITX)!=0);
 op->pr.fity=((pset.flags & OFITY)!=0);
 op->pr.centrex=((pset.flags & OCENTX)!=0);
 op->pr.centrey=((pset.flags & OCENTY)!=0);
 op->pr.regm=((pset.flags & OREGM)!=0);
 op->pr.sideways=((pset.flags & OPORT)==0);
 op->pr.cx=pset.cx;
 op->pr.cy=pset.cy;

 if(pset.flags & (OPAM|OGAL))
 {
  op->pr.scale=scale(0x10000,oldnewpage.width,oldnewpage.height);
  op->pr.aspect=0x10000;
 }
 else
 {
  op->pr.scale=scale(0x10000,pset.ymul,pset.ydiv);
  op->pr.aspect=scale(0x10000,pset.ymul*pset.xdiv,pset.ydiv*pset.xmul);
 }

 if(pset.flags & OPAM) op->pr.mode=PRPAM;
 else
 if(pset.flags & OGAL) op->pr.mode=PRGAL;

 op->pr.collate=collate;
 op->pr.backwards=reverse;
 op->pr.pause=pause;
 op->pr.nopics=!ppics;

 spellp=(spellstr*)fob_find(file->hdr.spell,file);
 spellp->continuous=ccheck;



 return(err);
}






static int repointsub(int x,int * bn,int bt,filestr * file)
{
 int          y;
 sobjectstr * sob;

 while(x)
 {
  if(*bn==bt) return(x);
  (*bn)++;

  sob=(sobjectstr*)fob_find(x,file);
  x=sob->chain.next;

  /* need to adjust count for main boxes */

  if(sob->type==OTEXTBOX)
  {
   if(((textboxstr*)sob)->data.repeat) (*bn)++;
   if(((textboxstr*)sob)->data.header) (*bn)++;
   if(((textboxstr*)sob)->data.footer) (*bn)++;
   (*bn)+=((textboxstr*)sob)->data.columns-1;
  }

  if(sob->chain.child)
  { 
   y=repointsub(sob->chain.child,bn,bt,file);
   if(y) return(y);
  }
 }

 return(0);
}



static int repoint(int pointer,filestr * file)
{
 int          section;
 sectionstr * sectionp;
 int          page;
 pagestr    * pagep;
 int          bt;
 int          pt;
 int          pn;
 int          bn;


 sectionp=NULL;  /* compiler */

 bt=((pointer>>16) & 0x7FFF)-1;
 pt=(pointer & 0xFFFF)-1;
 pn=0;
 bn=0;


 if(pt>file->hdr.np[DOC] || loadstylesheet)
 {
  if(!loadstylesheet) pn+=file->hdr.np[DOC];
  section=file->hdr.section[MST];
 }
 else 
  section=file->hdr.section[DOC];

 while(section)
 {
  sectionp=(sectionstr*)fob_find(section,file);
  if((pt-pn)<=sectionp->np) break;
  pn+=sectionp->np;
  section=sectionp->chain.next;
 }
 

 if(section)
 {
  page=sectionp->chain.child;
  while(page)
  {
   pagep=(pagestr*)fob_find(page,file);
   pn++;
   if(pn==pt)
   {
    return(repointsub(pagep->chain.child,&bn,bt,file));
   }
   page=pagep->chain.next;
  }
 }

 return(0);
}



/*
   if(((textboxstr*)sob)->fchain.prev & 0x80000000)
   {
    fprev=repoint(((textboxstr*)sob)->fchain.prev,file);
    dprintf(10,"fprev=%x",fprev);
    sob=fob_find(object,file);
    ((textboxstr*)sob)->fchain.prev=fprev;
    sob=fob_find(fprev,file);
    ((textboxstr*)sob)->fchain.next=object;
   }

   if(((textboxstr*)sob)->fchain.next & 0x80000000)
   {
    fnext=repoint(((textboxstr*)sob)->fchain.next,file);
    dprintf(11,"fnext=%x",fnext);
    sob=fob_find(object,file);
    ((textboxstr*)sob)->fchain.next=fnext;
    sob=fob_find(fnext,file);
    ((textboxstr*)sob)->fchain.prev=object;
   }

*/


/*
static void recalcpix(pictboxstr * pictp,aboxstr * abox,filestr * file)
{
 int xshift;
 int yshift;
 int h;


 xshift=pictp->pictdata.xshift;
 yshift=pictp->pictdata.yshift;


 h=scale(abox->y1-abox->y0,25,16);

 h=scale(h,pictp->pictdata.scale,0x10000);

 xshift=-xshift;
 yshift=pictp->fcurve.box.h-h+yshift;


 pictp->pictdata.xshift=xshift;
 pictp->pictdata.yshift=yshift;


 pictcalctransform(pictp->key,file);
}
*/





static void recalcpix(pictboxstr * pictp,aboxstr * aboxp,filestr * file)
{
 int              xshift;
 int              yshift;
 transformstr     tr1;
 transformstr     tr2;
 transformstr     tr;
 transformstr     ti1;
 transformstr     ti2;
 coordstr         cx;
 aboxstr          abox;
 int              xscale;
 int              yscale;
 transformbitstr  trb;


 abox.x0=scale(aboxp->x0,25,16);
 abox.x1=scale(aboxp->x1,25,16);
 abox.y0=scale(aboxp->y0,25,16);
 abox.y1=scale(aboxp->y1,25,16);


 xshift=pictp->pictdata.xshift;
 yshift=pictp->pictdata.yshift;

 tr_setshift(&tr1,-(abox.x0+abox.x1)/2,-(abox.y1+abox.y0)/2);
 tr_setshift(&tr2,(abox.x0+abox.x1)/2,(abox.y1+abox.y0)/2);

 tr_setidentity(&tr);
 tr_setrotationa(&tr,-pictp->pictdata.angle);

 tr_multiply(&ti1,&tr1,&tr);
 tr_multiply(&ti2,&ti1,&tr2);

 yscale=pictp->pictdata.scale;
 xscale=ttmul(yscale,pictp->pictdata.aspect);

 tr_setidentity(&tr);
 tr.a=xscale;
 tr.d=yscale;

 tr_multiply(&ti1,&ti2,&tr);

 cx.x=abox.x0;
 cx.y=abox.y1;

 tr_transformset(&cx,1,&ti1);

 cx.x-=scale(abox.x0,xscale,0x10000);
 cx.y-=scale(abox.y0,yscale,0x10000);

 xshift=cx.x-xshift;
 yshift=pictp->fcurve.box.h-(cx.y-yshift);


 xshift+=pictp->data.i;
 yshift-=pictp->data.i;


 pictp->pictdata.xshift=xshift;
 pictp->pictdata.yshift=yshift;


 tr_getbits(&ti1,&trb);

 pictp->pictdata.scale=trb.yscale;
 pictp->pictdata.aspect=scale(0x10000,trb.xscale,trb.yscale);

 pictp->pictdata.skew=-scaleatan(trb.skewxy);
 pictp->pictdata.angle=-trb.angle;

 pictcalctransform(pictp->key,file);
}






static os_error * relinkbox(int object,filestr * file)
{
 os_error   * err;
 sobjectstr * sob;
 int          fnext;
 int          next;
 int          source;
 int          vsource;
 texsrc     * texsp; 
 int          xobject;
 int          ftype;
 int          picture;
 int          copypicture;
 aboxstr      abox;
 int          voffset;
 int          lines;
 texsub     * texup;
 int          width[4];


 err=NULL;

 while(object && !err)
 {
  sob=(sobjectstr*)fob_find(object,file);
  next=sob->chain.next;

  if(sob->type==OTEXTBOX)
  {
   if(((textboxstr*)sob)->data.repeat)
      ((textboxstr*)sob)->master=lastmainbox;

   if(!((textboxstr*)sob)->fchain.prev)
   {
    texsp=(texsrc*)(((char*)sob)+sizeof(textboxstr));
    source=texsp[0].source;
    vsource=texsp[0].vsource;
    xobject=object;
    voffset=0;

    while(1)
    {
     texup=(texsub*)(((char*)sob)+sizeof(textboxstr)+sizeof(texsrc));
     lines=texup->vlines;

     if(!((textboxstr*)sob)->data.repeat &&
         ((textboxstr*)sob)->frame)
     {
      getbordersize(((textboxstr*)sob)->frame,file,
                                   width,&((textboxstr*)sob)->fcurve);
      ovlineshift(file,vsource,lines,voffset,-width[0],-width[0]);
     }

     voffset+=lines;

     if(((textboxstr*)sob)->fchain.next & 0x80000000)
     {
      fnext=repoint(((textboxstr*)sob)->fchain.next,file);
      sob=(sobjectstr*)fob_find(xobject,file);
      ((textboxstr*)sob)->fchain.next=fnext;
      sob=(sobjectstr*)fob_find(fnext,file);
      ((textboxstr*)sob)->fchain.prev=xobject;

      texsp=(texsrc*)(((char*)sob)+sizeof(textboxstr));
      texsp[0].source=source;
      texsp[0].vsource=vsource;
      xobject=fnext;
     }
     else
     {
      break;
     }
    }
   }

   /* relinkbox(box->u.text.child); */
  }
  else
  if(sob->type==OPICTBOX && sob->flags.changed)
  {
   ((pictboxstr*)sob)->flags.changed=0;
   picture=((pictboxstr*)sob)->picture;
   if(picture)
   {
    sob=(sobjectstr*)fob_find(picture,file);
    ftype=((picturestr*)sob)->ftype;
    abox=((picturestr*)sob)->abox;
            /* actually this gets repeated if don't use changed flags */
    sob=(sobjectstr*)fob_find(object,file);
    fnext=((pictboxstr*)sob)->ftype;
    ((pictboxstr*)sob)->ftype=ftype;
    recalcpix((pictboxstr*)sob,&abox,file);

    while(fnext & 0x80000000)
    {
     xobject=repoint(fnext,file);
     if(xobject)
     {
      err=fob_copy((fobjptr)&sob,file,picture,file);
      if(err) break;
      copypicture=sob->key;

      sob=(sobjectstr*)fob_find(xobject,file);
      fnext=((pictboxstr*)sob)->ftype;
      ((pictboxstr*)sob)->ftype=ftype;
      ((pictboxstr*)sob)->picture=copypicture;
      ((pictboxstr*)sob)->flags.changed=0;
      recalcpix((pictboxstr*)sob,&abox,file);
     }
    }
   }
  }

  object=next;
 }

 return(err);
}



/* scan through boxes and find resolved links */
/* convert into absolute addresses            */


static os_error * relink(filestr * file)
{
 os_error        * err;
 int               section;
 sectionstr      * sectionp;
 int               page;
 pagestr         * pagep;
 sectiondatastr    sdata;


 err=NULL;


 for(xbranch=loadstylesheet;xbranch<2;xbranch++)
 {
  section=file->hdr.section[xbranch];

  while(section)
  {
   sectionp=(sectionstr*)fob_find(section,file);
   page=sectionp->chain.child;
   section=sectionp->chain.next;
   sdata=sectionp->data;

   while(page)
   {
    pagep=(pagestr*)fob_find(page,file);
    page=pagep->chain.next;

    if(xbranch==MST) 
    {
     lastmainbox=0;
    }
    else
    {
     if(sdata.dble && (pagep->data.number & 0x1))
     {
      lastmainbox=sdata.mainkey[1];
     }
     else
     {
      lastmainbox=sdata.mainkey[0];
     }
    }

    err=relinkbox(pagep->chain.child,file);
    if(err) break;
   }
   if(err) break;
  }
  if(err) break;
 }

 return(err);
}



static int fmcode;



os_error * oloadfilepost(filestr * file,int ftype,int * load)
{
 *load=1;

 if(domapfonts(file,fmcode)) *load=0;
 else
 {



 }


#ifdef NEVER

 if(stylesheet)
 {
  gendocfrommasters();   /* generate doc from master pages */
  fh_new[file]=1;
 }

 mapfhdc(file);

#endif

 return(NULL);
 USE(file);
 USE(ftype);
}






static os_error * relinksections(filestr * file)
{
 int             msection;
 int             dsection;
 int             mnext;
 int             dnext;
 sectionstr    * sectionp;
 sectionmapstr   map;
 sectiondatastr  data;
 int             number;


 {
  msection=file->hdr.section[MST];
  dsection=file->hdr.section[DOC];
  number=1;

  while(dsection)
  {
   fob_mod(msection,file,(fobjptr)&sectionp);

   sectionp->dual=dsection;
   mnext=sectionp->chain.next;
   map=sectionp->map[0];
   data=sectionp->data;

   fob_mod(dsection,file,(fobjptr)&sectionp);
   sectionp->dual=msection;
   dnext=sectionp->chain.next;
   sectionp->data.number=number;
   sectionp->data.dble=data.dble;
   sectionp->data.mainkey[0]=data.mainkey[0];
   sectionp->data.mainkey[1]=data.mainkey[1];
   data=sectionp->data;

   map.dsource=sectionp->map[0].dsource;
   map.dvsource=sectionp->map[0].dvsource;
   sectionp->map[0]=map;

   fob_mod(msection,file,(fobjptr)&sectionp);
   sectionp->map[0]=map;
   sectionp->data=data;

   dsection=dnext;
   msection=mnext;

   number++;
  }
 }

 return(NULL);
}





/* load a native file into a buffer and open window */

os_error * oloadfile(char * name,buffer * bf,int stylesheet,filestr * file)
{
 os_error * err;
 int        temp;
 int        np;
 int        ns;
 int        i;
 filehdr  * hdr;



 err=ob_createdomain((domainstr**)&file->domain);
 if(!err)
 {
  err=fob_create(sizeof(filehdr),file,OFILEHDR,(fobjptr)&hdr);
  if(!err)
  {
   file->hdr=*hdr;

   for(i=EVENT_NEWDOC0;i<=EVENT_NEWDOC7;i++)
   {
    err=event(i,file,NULL);
    if(err) break;
   }
  }
 }


 if(!err)
 {
  loadstylesheet=stylesheet;
  maxpagewidth=0;
  maxpageheight=0;

  bf_seek(bf,0);

  err=readfileblock(bf,file);
  if(!err)
  {
   err=readfontmap(bf,file,&fmcode);   /* flex_alloc() stuff - oclear styles */
   if(!err)
   {
             err=loadparas(bf,file);
    if(!err) err=loadstyles(bf,file);
    if(!err) err=loadfstyles(bf,file);

    if(!err)
    {
     for(xbranch=stylesheet;xbranch<2;xbranch++)
     {
      bf_geti(bf,&np);
      bf_geti(bf,&ns);

      temp=1;
      err=loadxstr(0,&temp,bf,file); /* force it to load something */
      if(err) break;

      file->hdr.ns[xbranch]=ns;
      file->hdr.np[xbranch]=np;
      file->hdr.section[xbranch]=temp;
      file->hdr.maxpagewidth[DOC]=file->hdr.maxpagewidth[MST]=maxpagewidth;
      file->hdr.maxpageheight[DOC]=file->hdr.maxpageheight[MST]=maxpageheight;
     }
    }

    if(!err)
    {
     if(!stylesheet) relinksections(file);
     err=relink(file);
    }

    oclearstyles();

    if(!err)
    {
     for(i=EVENT_NEWDOC9;i<=EVENT_NEWDOCF;i++)
     {
      err=event(i,file,NULL);
      if(err) break;
     }
    }
   }
  }

		

  if(err) ob_deletedomain((domainstr**)&file->domain);
 }

 return(err);

 USE(name);
}


static errtag errortable[]=
{
 EO100, "Bad object type found",

 ELAST , ""
};

static errlink erroro1;



extern "C" __declspec(dllexport) os_error * entrypoint(char * path)
{ 
 os_error * err;

 registeroload(oloadfile,oloadfilepost);
 err=adderrortable(errortable,&erroro1);

 if(!getenv("Ovation1$NoRun"))
 {
           err=adddataopen(FTYPE,loaddoc);
  if(!err) err=adddataopenpost(FTYPE,loaddocpost);
  if(!err) err=adddataopen(STYPE,loaddoc);
  if(!err) err=adddataopenpost(STYPE,loaddocpost);
 }

 return(err);
 USE(path);
}






extern "C" BOOL __stdcall _DllMainCRTStartup( 
    HINSTANCE hinstDLL,     // handle to DLL module 
    DWORD fdwReason,        // reason for calling function 
    LPVOID lpvReserved)     // reserved 
{
 
 modulehandle=(HMODULE)hinstDLL;
 return(TRUE);
}
